import { defineComponent, $prefix, setup as _setup } from "@xmweb-ui/vue-common";
import { renderless, api } from "@xmweb-ui/vue-renderless/tree-menu/vue";
import Tree from "@xmweb-ui/vue-tree";
import Input from "@xmweb-ui/vue-input";
import { iconLeftWardArrow, iconSearch } from "@xmweb-ui/vue-icon";
function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function hook2(context) {
      context = context || // cached call
      this.$vnode && this.$vnode.ssrContext || // stateful
      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(this, (options.functional ? this.parent : this).$root.$options.shadowRoot);
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

import "@xmweb-ui/vue-theme/tree-menu/index.css";
var __vue2_script = defineComponent({
  name: $prefix + "TreeMenu",
  components: {
    XmTree: Tree,
    XmInput: Input,
    IconArrow: iconLeftWardArrow()
  },
  props: {
    data: Array,
    nodeKey: String,
    defaultExpandAll: Boolean,
    suffixIcon: Object,
    prefixIcon: Object,
    searchIcon: {
      type: Object,
      default: function _default() {
        return iconSearch();
      }
    },
    props: Object,
    draggable: {
      type: Boolean,
      default: false
    },
    emptyText: {
      type: String,
      default: ""
    },
    checkStrictly: Boolean,
    lazy: {
      type: Boolean,
      default: false
    },
    load: Function,
    showCheckbox: Boolean,
    filterNodeMethod: Function,
    defaultCheckedKeys: Array,
    defaultExpandedKeys: Array,
    defaultExpandedKeysHighlight: [Number, String],
    indent: {
      type: Number,
      default: 16
    },
    allowDrag: Function,
    allowDrop: Function,
    expandOnClickNode: {
      type: Boolean,
      default: true
    },
    ellipsis: {
      type: Boolean,
      default: false
    },
    wrap: {
      type: Boolean,
      default: false
    },
    getMenuDataSync: Function,
    accordion: Boolean,
    showTitle: {
      type: Boolean,
      default: true
    },
    showFilter: {
      type: Boolean,
      default: true
    },
    collapsible: {
      type: Boolean,
      default: false
    }
  },
  setup: function setup(props, context) {
    return _setup({
      props,
      context,
      renderless,
      api,
      mono: true
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "xm-tree-menu",
    class: {
      "is-collapsed": _vm.state.isCollapsed
    }
  }, [_vm.collapsible ? _c("div", {
    staticClass: "xm-tree-menu__toggle-button",
    on: {
      "click": function click($event) {
        $event.stopPropagation();
        return _vm.collapseChange.apply(null, arguments);
      }
    }
  }, [_c("icon-arrow")], 1) : _vm._e(), _vm.showFilter ? _c("xm-input", {
    attrs: {
      "placeholder": _vm.t("ui.treeMenu.placeholder"),
      "prefix-icon": _vm.searchIcon
    },
    model: {
      value: _vm.state.filterText,
      callback: function callback($$v) {
        _vm.$set(_vm.state, "filterText", $$v);
      },
      expression: "state.filterText"
    }
  }) : _vm._e(), _c("xm-tree", {
    ref: "tree",
    class: {
      "xm-tree-menu__wrap": !_vm.ellipsis ? _vm.wrap : false,
      "xm-tree-menu__overflow": _vm.ellipsis
    },
    attrs: {
      "xm_mode": "pc",
      "accordion": _vm.accordion,
      "data": _vm.state.data,
      "node-key": _vm.nodeKey,
      "empty-text": _vm.emptyText,
      "filter-node-method": _vm.filterNodeMethod || _vm.filterNode,
      "draggable": _vm.draggable,
      "default-expand-all": _vm.defaultExpandAll,
      "check-strictly": _vm.checkStrictly,
      "lazy": _vm.lazy,
      "load": _vm.load,
      "show-checkbox": _vm.showCheckbox,
      "indent": _vm.indent,
      "default-checked-keys": _vm.defaultCheckedKeys,
      "default-expanded-keys": _vm.defaultExpandedKeys,
      "default-expanded-keys-highlight": _vm.defaultExpandedKeysHighlight,
      "allow-drag": _vm.allowDrag,
      "props": _vm.props,
      "allow-drop": _vm.allowDrop,
      "expand-on-click-node": _vm.expandOnClickNode
    },
    on: {
      "node-drag-start": _vm.nodeDragStart,
      "node-drag-enter": _vm.nodeDragEnter,
      "node-drag-over": _vm.nodeDragOver,
      "node-drag-end": _vm.nodeDragEnd,
      "node-drop": _vm.nodeDrop,
      "node-expand": _vm.nodeExpand,
      "node-collapse": _vm.nodeCollapse,
      "node-click": _vm.nodeClick,
      "check-change": _vm.checkChange,
      "check": _vm.check,
      "current-change": _vm.currentChange
    },
    scopedSlots: _vm._u([{
      key: "default",
      fn: function fn(_ref) {
        var node = _ref.node, data = _ref.data;
        return [_c("div", {
          staticClass: "tree-node"
        }, [_c("div", {
          staticClass: "tree-menus-link xm-tree-node__label"
        }, [_c("a", {
          staticClass: "tree-node-body",
          attrs: {
            "title": _vm.getTitle(data.label),
            "href": data.url || void 0
          }
        }, [_c("span", {
          staticClass: "tree-node-name"
        }, [_vm.prefixIcon ? _c(_vm.prefixIcon, {
          tag: "component"
        }) : _vm._e(), _vm._t("default", function() {
          return [_vm._v(" " + _vm._s(data.label || node.label) + " ")];
        }, {
          "node": node,
          "data": data,
          "label": data.label
        })], 2)])])])];
      }
    }], null, true)
  })], 1);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles, null, null, null);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var TreeMenu = /* @__PURE__ */ function() {
  return __component__.exports;
}();
var version = "2.8.0";
TreeMenu.install = function(Vue) {
  Vue.component(TreeMenu.name, TreeMenu);
};
TreeMenu.version = version;
export {
  TreeMenu as default
};
